clear
close all

disp('----- NUM. OF EXPT --------');
expt=input('expt?--------------->');

rest=expt-fix(expt);
if(rest==0)
    expstr=([num2str(expt),'.0']);
else
    expstr=num2str(expt);
end 
    
    
%disp('---- DOMAIN DIMENSIONS ----');
%idm=input('idm?----------------->');
%jdm=input('jdm?----------------->');
%kdm=input('kdm?----------------->');

idm=16;
jdm=16;
kdm=15;

disp('---------- TIME -----------'); 
year=input('Year?--------------->');
day= input('Day?---------------->');
hour=input('Hour?--------------->');

if(hour<10)
    hourstr=(['0',num2str(hour)]);
else
    hourstr=num2str(hour);
end 

%
% --- get grid/depth info ...
%

fid=fopen('../topo/regional.grid.a', 'r', 'ieee-be');
% first two are lon/lat
 plon=readHycomA(fid,idm,jdm);
 plat=readHycomA(fid,idm,jdm); 
fclose(fid);

fid=fopen('../topo/depth_INBa4.00_01.a', 'r', 'ieee-be');
 depth=readHycomA(fid,idm,jdm);
fclose(fid);

%
% --- get output values
%
if(year<10)   
 if(day<10)
   fid=fopen(['../expt_0',expstr,'/data/archv.000',num2str(year),'_00',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
 elseif(day<100)
   fid=fopen(['../expt_0',expstr,'/data/archv.000',num2str(year),'_0',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
 else
   fid=fopen(['../expt_0',expstr,'/data/archv.000',num2str(year),'_',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
 end %if(day)
elseif(year<100)
 if(day<10)
   fid=fopen(['../expt_0',expstr,'/data/archv.00',num2str(year),'_00',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
 elseif(day<100)
   fid=fopen(['../expt_0',expstr,'/data/archv.00',num2str(year),'_0',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
 else
   fid=fopen(['../expt_0',expstr,'/data/archv.00',num2str(year),'_',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
 end %if(day)
else
 if(day<10)   
   fid=fopen(['../expt_0',expstr,'/data/archv.0',num2str(year),'_00',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
 elseif(day<100)
   fid=fopen(['../expt_0',expstr,'/data/archv.0',num2str(year),'_0',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
 else
   fid=fopen(['../expt_0',expstr,'/data/archv.0',num2str(year),'_',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
 end %if(day)
end %if(year)   
% --- 2D arrays
     montg1(:,:)   =readHycomA(fid,idm,jdm);
     srfhgt(:,:)   =readHycomA(fid,idm,jdm);
     surflx(:,:)   =readHycomA(fid,idm,jdm);
     salflx(:,:)   =readHycomA(fid,idm,jdm);
     bl_dpth(:,:)  =readHycomA(fid,idm,jdm);
     mix_dpth(:,:) =readHycomA(fid,idm,jdm);
     tmix(:,:)     =readHycomA(fid,idm,jdm);
     smix(:,:)     =readHycomA(fid,idm,jdm);
     thmix(:,:)    =readHycomA(fid,idm,jdm);
     umix(:,:)     =readHycomA(fid,idm,jdm);
     vmix(:,:)     =readHycomA(fid,idm,jdm);
     u_btrop(:,:)  =readHycomA(fid,idm,jdm);
     v_btrop(:,:)  =readHycomA(fid,idm,jdm);
% --- 3D arrays
     for k=1:kdm
         u(:,:,k)      =readHycomA(fid,idm,jdm);
         v(:,:,k)      =readHycomA(fid,idm,jdm);
         thknss(:,:,k) =readHycomA(fid,idm,jdm);
         temp(:,:,k)   =readHycomA(fid,idm,jdm);
         salin(:,:,k)  =readHycomA(fid,idm,jdm);
         density(:,:,k)=readHycomA(fid,idm,jdm);
     end
     for k=1:kdm
         diafx000(:,:,k)=readHycomA(fid,idm,jdm);
     end
     fclose(fid);


%
% --- transf. of thknss from press units to meters
%

thref=1e-03; %spec. volume in m3/kg
onem=9806; %grav. acc. * 1000 Kg/m3 (qthref=1/thref)
thknss=thknss./onem;

%
% --- transf. of srfhgt in millimeters
%

onemm=9.806;
srfhgt=srfhgt./(onemm*thref);

%
% --- interfacial heights are obtained
% --- recursively from the bottom (pag 174 Cushman)
% --- NB in our case z1 --> z0 Cushman 
% --- so the three layers system of Cushmann is
% --- z4 = -H
% --- z3 = h3 - H = h3 + z4
% --- z2 = h2 + h3 - H = h2 + z3
% --- z1 = h1 + h2 + h3 - H = h1 + z2
% --- generalizing having defined z(kmax+1)
% --- we obtain the other with
% --- z(k)= h(k) + z(k+1) with k=kmax to 1
%

kdm1=kdm+1;

% --- initialize depth interfaces
dep_int=zeros(jdm,idm,kdm1);

dep_int(:,:,kdm1)=-depth;


for k=kdm:-1:1
    dep_int(:,:,k)=thknss(:,:,k) + dep_int(:,:,k+1);
end %for k
