function [aout] = readHycomA(fid,idm,jdm)
%readHycomA reads one line of the .a file output from Hycom
%  aout is the matrix read  
%  assumes the file is already opened
%  with identifier FID
%
%  Gatimu 11/13/2004

 nt=idm*jdm;   
 nta=floor((nt+4095)/4096)*4096;
 aout=fread(fid,[1,    nt],'real*4');
 dum =fread(fid,[1,nta-nt],'real*4');
 aout=reshape(aout,idm,jdm);
 
%RESHAPE Change size.
%    RESHAPE(X,M,N) returns the M-by-N matrix whose elements
%    are taken columnwise from X.  An error results if X does
%    not have M*N elements.
%  
%    RESHAPE(X,M,N,P,...) returns an N-D array with the same
%    elements as X but reshaped to have the size M-by-N-by-P-by-...
%    M*N*P*... must be the same as PROD(SIZE(X)).
%  
%    RESHAPE(X,[M N P ...]) is the same thing.
%  
%    RESHAPE(X,...,[],...) calculates the length of the dimension
%    represented by [], such that the product of the dimensions
%    equals PROD(SIZE(X)). PROD(SIZE(X)) must be evenly divisible
%    by the product of the known dimensions. You can use only one
%    occurrence of [].
%  
%    In general, RESHAPE(X,SIZ) returns an N-D array with the same
%    elements as X but reshaped to the size SIZ.  PROD(SIZ) must be
%    the same as PROD(SIZE(X)).
%
%  EXAMPLE:
%
%  a =
% 
%     1     2     3     4     5     6     7     8     9
% 
%  a=reshape(a,3,3)
% 
%  a =
% 
%     1     4     7
%     2     5     8
%     3     6     9
 

% --- so for how reshape works I need to traspose the matrix

 aout=aout';
 
% --- remove land mask huge=2^100=1.2677*10^30 
 
 [landposX,landposY]=find(aout>1e30);

 if(size(landposX,1)>0)
    for i=1:size(landposX,1)
         aout(landposX(i),landposY(i))=nan;
     end
 end