clear
close all

disp('----- NUM. OF EXPT --------');
expt=input('expt?--------------->');

rest=expt-fix(expt);
if(rest==0)
    expstr=([num2str(expt),'.0']);
else
    expstr=num2str(expt);
end 
    
    
%disp('---- DOMAIN DIMENSIONS ----');
%idm=input('idm?----------------->');
%jdm=input('jdm?----------------->');
%kdm=input('kdm?----------------->');

idm=16;
jdm=16;
kdm=15;

%
% --- get grid/depth info ...
%

fid=fopen('../topo/regional.grid.a', 'r', 'ieee-be');
% first two are lon/lat
 plon=readHycomA(fid,idm,jdm);
 plat=readHycomA(fid,idm,jdm); 
fclose(fid);

fid=fopen('../topo/depth_INBa4.00_01.a', 'r', 'ieee-be');
 depth=readHycomA(fid,idm,jdm);
fclose(fid);



disp('---------- TIME -----------'); 
year=input('Year?--------------->');
Iday=input('Initial Day?-------->');
Fday=input('Final Day?---------->');
%hour=input('Hour?--------------->');

%possible_hours=[0 2 4 7 9 12 14 16 19 21];
possible_hours=[0 1 3 4 6 8 9 11 12 14 16 17 19 20 22];

%
% --- get output values
%
   

itI=0;
itF=0;
numhours=size(possible_hours,2);
for day=Iday:Fday
    itminus=itF;
    itI=itF+1;
    itF=itF+numhours;
    for it=itI:itF
     hour=possible_hours(it-itminus);   
     if(hour<10)
         hourstr=(['0',num2str(hour)]);
     else
         hourstr=num2str(hour);
     end 
%
% --- get output values
%
     if(year<10)   
         if(day<10)
             fid=fopen(['../expt_0',expstr,'/data/archv.000',num2str(year),'_00',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
         elseif(day<100)
             fid=fopen(['../expt_0',expstr,'/data/archv.000',num2str(year),'_0',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
         else
             fid=fopen(['../expt_0',expstr,'/data/archv.000',num2str(year),'_',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
         end %if(day)
     elseif(year<100)
         if(day<10)
             fid=fopen(['../expt_0',expstr,'/data/archv.00',num2str(year),'_00',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
         elseif(day<100)
             fid=fopen(['../expt_0',expstr,'/data/archv.00',num2str(year),'_0',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
         else
             fid=fopen(['../expt_0',expstr,'/data/archv.00',num2str(year),'_',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
         end %if(day)
     else
         if(day<10)   
             fid=fopen(['../expt_0',expstr,'/data/archv.0',num2str(year),'_00',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
         elseif(day<100)
             fid=fopen(['../expt_0',expstr,'/data/archv.0',num2str(year),'_0',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
         else
             fid=fopen(['../expt_0',expstr,'/data/archv.0',num2str(year),'_',num2str(day),'_',hourstr,'.a'], 'r', 'ieee-be');
         end %if(day)
     end %if(year)   
% --- 2D arrays
     montg1(:,:,it)   =readHycomA(fid,idm,jdm);
     srfhgt(:,:,it)   =readHycomA(fid,idm,jdm);
     surflx(:,:,it)   =readHycomA(fid,idm,jdm);
     salflx(:,:,it)   =readHycomA(fid,idm,jdm);
     bl_dpth(:,:,it)  =readHycomA(fid,idm,jdm);
     mix_dpth(:,:,it) =readHycomA(fid,idm,jdm);
     tmix(:,:,it)     =readHycomA(fid,idm,jdm);
     smix(:,:,it)     =readHycomA(fid,idm,jdm);
     thmix(:,:,it)    =readHycomA(fid,idm,jdm);
     umix(:,:,it)     =readHycomA(fid,idm,jdm);
     vmix(:,:,it)     =readHycomA(fid,idm,jdm);
     u_btrop(:,:,it)  =readHycomA(fid,idm,jdm);
     v_btrop(:,:,it)  =readHycomA(fid,idm,jdm);
% --- 3D arrays
     for k=1:kdm
         u(:,:,k,it)      =readHycomA(fid,idm,jdm);
         v(:,:,k,it)      =readHycomA(fid,idm,jdm);
         thknss(:,:,k,it) =readHycomA(fid,idm,jdm);
         temp(:,:,k,it)   =readHycomA(fid,idm,jdm);
         salin(:,:,k,it)  =readHycomA(fid,idm,jdm);
         density(:,:,k,it)=readHycomA(fid,idm,jdm);
     end
     for k=1:kdm
         diafx000(:,:,k,it)=readHycomA(fid,idm,jdm);
     end
     fclose(fid);
    end %for it
end %for day

%
% --- transf. of thknss from press units to meters
%

thref=1e-03; %spec. volume in m3/kg
onem=9806; %grav. acc. * 1000 Kg/m3 (qthref=1/thref)
thknss=thknss./onem;

%
% --- transf. of srfhgt in millimeters
%

onemm=9.806;
srfhgt=srfhgt./(onemm*thref);

%
% --- interfacial heights are obtained
% --- recursively from the bottom (pag 174 Cushman)
% --- NB in our case z1 --> z0 Cushman 
% --- so the three layers system of Cushmann is
% --- z4 = -H
% --- z3 = h3 - H = h3 + z4
% --- z2 = h2 + h3 - H = h2 + z3
% --- z1 = h1 + h2 + h3 - H = h1 + z2
% --- generalizing having defined z(kmax+1)
% --- we obtain the other with
% --- z(k)= h(k) + z(k+1) with k=kmax to 1
%

kdm1=kdm+1;
itmax=size(montg1,3);

% --- initialize depth interfaces
dep_int=zeros(jdm,idm,kdm1,itmax);

for it=1:itmax
    dep_int(:,:,kdm1,it)=-depth;
end %for it

for k=kdm:-1:1
    dep_int(:,:,k,:)=thknss(:,:,k,:) + dep_int(:,:,k+1,:);
end %for k