clear
close all

disp('----- NUM. OF EXPT --------');
expt=input('expt?--------------->');

rest=expt-fix(expt);
if(rest==0)
    expstr=([num2str(expt),'.0']);
else
    expstr=num2str(expt);
end 
    
    
%disp('---- DOMAIN DIMENSIONS ----');
%idm=input('idm?----------------->');
%jdm=input('jdm?----------------->');
%kdm=input('kdm?----------------->');

idm=16;
jdm=16;
kdm=15;

disp('---------- TIME -----------'); 
tmax=input('Max. time?--------->');
tint=input('Time interval?------>');

iyear=1;
day=196:tint:tmax;

%
% --- get grid/depth info ...
%

fid=fopen('../topo/regional.grid.a', 'r', 'ieee-be');
% first two are lon/lat
 plon=readHycomA(fid,idm,jdm);
 plat=readHycomA(fid,idm,jdm); 
fclose(fid);

fid=fopen('../topo/depth_INBa4.00_01.a', 'r', 'ieee-be');
 depth=readHycomA(fid,idm,jdm);
fclose(fid);

%
% --- get output values
%

for it=1:size(day,2)
     if(day(it)<10)
          fid=fopen(['../expt_0',expstr,'/data/archv.000',num2str(iyear),'_00',num2str(day(it)),'_00.a'], 'r', 'ieee-be');
     elseif(day(it)<100)
          fid=fopen(['../expt_0',expstr,'/data/archv.000',num2str(iyear),'_0',num2str(day(it)),'_00.a'], 'r', 'ieee-be');
     else
          fid=fopen(['../expt_0',expstr,'/data/archv.000',num2str(iyear),'_',num2str(day(it)),'_00.a'], 'r','ieee-be'); 
     end %if(day)
      
% --- 2D arrays
     montg1(:,:,it)   =readHycomA(fid,idm,jdm);
     srfhgt(:,:,it)   =readHycomA(fid,idm,jdm);
     surflx(:,:,it)   =readHycomA(fid,idm,jdm);
     salflx(:,:,it)   =readHycomA(fid,idm,jdm);
     bl_dpth(:,:,it)  =readHycomA(fid,idm,jdm);
     mix_dpth(:,:,it) =readHycomA(fid,idm,jdm);
     tmix(:,:,it)     =readHycomA(fid,idm,jdm);
     smix(:,:,it)     =readHycomA(fid,idm,jdm);
     thmix(:,:,it)    =readHycomA(fid,idm,jdm);
     umix(:,:,it)     =readHycomA(fid,idm,jdm);
     vmix(:,:,it)     =readHycomA(fid,idm,jdm);
     u_btrop(:,:,it)  =readHycomA(fid,idm,jdm);
     v_btrop(:,:,it)  =readHycomA(fid,idm,jdm);
% --- 3D arrays
     for k=1:kdm
         u(:,:,k,it)      =readHycomA(fid,idm,jdm);
         v(:,:,k,it)      =readHycomA(fid,idm,jdm);
         thknss(:,:,k,it) =readHycomA(fid,idm,jdm);
         temp(:,:,k,it)   =readHycomA(fid,idm,jdm);
         salin(:,:,k,it)  =readHycomA(fid,idm,jdm);
         density(:,:,k,it)=readHycomA(fid,idm,jdm);
     end
     for k=1:kdm
         diafx000(:,:,k,it)=readHycomA(fid,idm,jdm);
     end
     fclose(fid);
end %for it


%
% --- transf. of thknss from press units to meters
%

thref=1e-03; %spec. volume in m3/kg
onem=9806; %grav. acc. * 1000 Kg/m3 (qthref=1/thref)
thknss=thknss./onem;

%
% --- transf. of srfhgt in millimeters
%

onemm=9.806;
srfhgt=srfhgt./(onemm*thref);

%
% --- interfacial heights are obtained
% --- recursively from the bottom (pag 174 Cushman)
% --- NB in our case z1 --> z0 Cushman 
% --- so the three layers system of Cushmann is
% --- z4 = -H
% --- z3 = h3 - H = h3 + z4
% --- z2 = h2 + h3 - H = h2 + z3
% --- z1 = h1 + h2 + h3 - H = h1 + z2
% --- generalizing having defined z(kmax+1)
% --- we obtain the other with
% --- z(k)= h(k) + z(k+1) with k=kmax to 1
%

kdm1=kdm+1;
itmax=size(montg1,3);

% --- initialize depth interfaces
dep_int=zeros(jdm,idm,kdm1,itmax);

for it=1:itmax
    dep_int(:,:,kdm1,it)=-depth;
end %for it

for k=kdm:-1:1
    dep_int(:,:,k,:)=thknss(:,:,k,:) + dep_int(:,:,k+1,:);
end %for k



%saves all current workspace variables to the file *.mat
expt=expt*10;
savefile=['0',num2str(expt),'.mat'];
disp(['Do you want to overwrite ',savefile,' ?']);
disp('Yes---------------------------> 1');
disp('No----------------------------> 0');
owr=input('------------------------------> ');


if(owr==1)
    save(savefile);
end    