close all
clear x y z sal temper dens

scrsz=get(0,'ScreenSize');

figure(1)
%[left bottom width height]
set(1,'Position',[10 scrsz(4)/2-80 scrsz(3)-20 scrsz(4)/2]) 

    x=repmat(plon(1,:), [kdm 1])';
    z=squeeze(dep_int(10,:,2:end));
    z(isnan(z))=0; %cannot use as coordinate a variable with NaNs
    sal=squeeze(salin(10,:,:));
    temper=squeeze(temp(10,:,:));
    dens=squeeze(density(10,:,:));
    
    subplot(1,3,1)
    surf(x,z,0*sal,sal); view([0 90]); shading flat; colorbar;
    axis([min(min(x)) max(max(x)) -5800 1]);
    %xlabel('Longitude'); 
    ylabel('Depth (m)');
    title('Salinity');
    hold on
    plot(x(:,1),z,'k');
    hold off    

    subplot(1,3,2)
    surf(x,z,0*temper,temper); view([0 90]); shading flat; colorbar;
    axis([min(min(x)) max(max(x)) -5800 1]);
    xlabel('Longitude'); 
    %ylabel('Depth (m)');
    title('Temperature');
    hold on
    plot(x(:,1),z,'k');                                                    
    hold off
    
    subplot(1,3,3)
    surf(x,z,0*dens,dens); view([0 90]); shading flat; colorbar;
    axis([min(min(x)) max(max(x)) -5800 1]);
    %xlabel('Longitude'); 
    %ylabel('Depth (m)');
    title('Density');
    hold on
    plot(x(:,1),z,'k');                                                    
    hold off